"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ListOfPropertiesRuleBuilder = void 0;
class ListOfPropertiesRuleBuilder {
    constructor(property, addDependencies) {
        this.addDependencies = addDependencies;
        this.property = property;
    }
    addValidator(...dependencies) {
        this.addDependencies(dependencies, this.property, { validation: true });
        return validator => {
            this.property.addPropertyValidator(validator, dependencies);
            return this;
        };
    }
    addAsyncValidator(...dependencies) {
        this.addDependencies(dependencies, this.property, { validation: true });
        return validator => {
            this.property.addAsyncPropertyValidator(validator, dependencies);
            return this;
        };
    }
}
exports.ListOfPropertiesRuleBuilder = ListOfPropertiesRuleBuilder;
