import { PropertyDependencyOptions } from "../../dependency-graph/property-dependency";
import { AbstractProperty } from "../../properties/abstract-property";
import { PropertyArrayList } from "../../properties/property-array-list";
import { AsyncPropertyArrayListValidator } from "../../validators/async-property-validator";
import { PropertyArrayListValidator } from "../../validators/property-validator";
export declare class PropertyArrayListRuleBuilder<T> {
    private readonly addDependencies;
    private readonly property;
    constructor(property: PropertyArrayList<T>, addDependencies: (from: readonly AbstractProperty[], to: AbstractProperty, options: PropertyDependencyOptions) => void);
    addValidator<Dependencies extends readonly AbstractProperty[]>(...dependencies: Dependencies): (validator: PropertyArrayListValidator<T, Dependencies>) => PropertyArrayListRuleBuilder<T>;
    addAsyncValidator<Dependencies extends readonly AbstractProperty[]>(...dependencies: Dependencies): (validator: AsyncPropertyArrayListValidator<T, Dependencies>) => PropertyArrayListRuleBuilder<T>;
}
