export class GroupOfPropertiesRuleBuilder {
    constructor(property, addDependencies) {
        this.addDependencies = addDependencies;
        this.property = property;
    }
    addValidator(...dependencies) {
        this.addDependencies(dependencies, this.property, { validation: true });
        return validator => {
            this.property.addPropertyValidator(validator, dependencies);
            return this;
        };
    }
    addAsyncValidator(...dependencies) {
        this.addDependencies(dependencies, this.property, { validation: true });
        return validator => {
            this.property.addAsyncPropertyValidator(validator, dependencies);
            return this;
        };
    }
    addCrossValidator(validator) {
        const instance = {
            validationArguments: this.property.propertiesAsList,
            validate: () => validator(this.property.properties)
        };
        this.property.addValidator(instance);
        return this;
    }
}
