import { PropertyDependencyOptions } from "../../dependency-graph/property-dependency";
import { AsyncListOfPropertiesValidator } from "../../index";
import { AbstractDataProperty } from "../../properties/abstract-data-property";
import { AbstractProperty } from "../../properties/abstract-property";
import { ListOfProperties } from "../../properties/list-of-properties";
import { ListOfPropertiesValidator } from "../../validators/property-validator";
export declare class ListOfPropertiesRuleBuilder<T extends AbstractDataProperty<D>, D> {
    private readonly addDependencies;
    private readonly property;
    constructor(property: ListOfProperties<T, D>, addDependencies: (from: readonly AbstractProperty[], to: AbstractProperty, options: PropertyDependencyOptions) => void);
    addValidator<Dependencies extends readonly AbstractProperty[]>(...dependencies: Dependencies): (validator: ListOfPropertiesValidator<T, D, Dependencies>) => ListOfPropertiesRuleBuilder<T, D>;
    addAsyncValidator<Dependencies extends readonly AbstractProperty[]>(...dependencies: Dependencies): (validator: AsyncListOfPropertiesValidator<T, D, Dependencies>) => ListOfPropertiesRuleBuilder<T, D>;
}
