import { AbstractProperty, GroupOfProperties, PropertyGroup } from "../index";
import { AbstractDataProperty } from "../properties/abstract-data-property";
import { ListOfProperties } from "../properties/list-of-properties";
import { PropertyArrayList } from "../properties/property-array-list";
import { PropertyScalar } from "../properties/property-scalar";
import { ValidationMessage } from "./validation-message";
export declare type PropertyValidator<T extends AbstractDataProperty<unknown>, Dependencies extends readonly AbstractProperty[]> = (property: T, ...dependencies: Dependencies) => ValidationMessage | void;
export declare type PropertyScalarValidator<T, Dependencies extends readonly AbstractProperty[]> = PropertyValidator<PropertyScalar<T>, Dependencies>;
export declare type GroupOfPropertiesValidator<T extends PropertyGroup, Dependencies extends readonly AbstractProperty[]> = PropertyValidator<GroupOfProperties<T>, Dependencies>;
export declare type PropertyArrayListValidator<T, Dependencies extends readonly AbstractProperty[]> = PropertyValidator<PropertyArrayList<T>, Dependencies>;
export declare type ListOfPropertiesValidator<T extends AbstractDataProperty<D>, D, Dependencies extends readonly AbstractProperty[]> = PropertyValidator<ListOfProperties<T, D>, Dependencies>;
