import { ValidationMessage } from "./validation-message";
import { ValidationType } from "./validation-type";
import { ValidationMessagesMap } from "./validation-messages-map";
export declare class ValidationResult {
    private readonly validationMessagesMap;
    constructor(validationMessagesMap: ValidationMessagesMap);
    getValidationMessagesMap(): ValidationMessagesMap;
    getAllMessages(): ValidationMessage[];
    private flatten;
    getAllMessagesOfType(type: ValidationType): ValidationMessage[];
    getAllValidMessages(): ValidationMessage[];
    getAllInvalidMessages(): ValidationMessage[];
    getAllMessagesBy(fcn: (msg: ValidationMessage) => boolean): ValidationMessage[];
    filterByType(type: ValidationType): ValidationMessagesMap;
    filterValid(): ValidationMessagesMap;
    filterInvalid(): ValidationMessagesMap;
    filterBy(fcn: (msg: ValidationMessage) => boolean): ValidationMessagesMap;
}
